#include <iostream>
#include <cmath>

using namespace std;

int main()
{
    int n,m,c,b[100001],a[100001];
    cin >> n >> m;
    for (int i=1;i<=m;i++)
        cin >> b[i];
    for (int i=1;i<=n;i++)
        a[i]=i;
    for (int i=0;i<=n-m;i++)
        for (int j=1;j<m;j++)
        a[i + b[j]] = a[i + j];
    cin >> c;
    long long x=0;
    for (int i=1;i<=n;i++)
        x+=(pow(c,i)*a[i]);
    cout << (x%998244353) << endl;
    return 0;
}